
function playerMain();
function createHill(who,VECTOR* pos);
function playerHill();

function antAdd(ENTITY* who);
function antMain();
function antLoop();
function antMove();
function antInput();

function pheromoneAdd(ENTITY* who,val);
function pheromoneMain();

function listAdd(list,ENTITY* who);

var moveSpeed=2;
var rotateSpeed=20;


function playerCreate(){
	me=ent_create(NULL,NULLVECTOR,NULL);
	player=me;
	my.id=1;	
	my.typ=TYP_PLAYER;
	c_trace(vector(0,0,1000),vector(0,0,-1000),USE_POLYGON|IGNORE_PASSABLE|IGNORE_SPRITES);
	createHill(my.id,target);
}


function playerMain(){	
	wait(1);
}

function createHill(who,VECTOR* pos){
	you=ent_create("hill.mdl",pos,playerHill);
	you.id=who;
}

function playerHill(){
	set(my,PASSABLE);
	my.typ=TYP_COLONY;
	my.food=0;	
	int n;
	for(n=0;n<3;n++){
		antAdd(me);	
		wait(-1);
	}
	
	while(1){
		if(my.food>=5)	{
			antAdd(me);
			my.food-=5;
		}
		
		wait(1);
	}
}

function antAdd(ENTITY* who){
	you=ent_create("ant.mdl",who.x,antMain);
	you.id=who.id;	
	you.colony=handle(who);
}

function antMain(){
	set(my,SHADOW);
	my.typ=TYP_ANT;	
	my.carry=0;
	antLoop();	
}

function antLoop(){
	my.pan=random(360);	
	var step;
	var step2;
	var lastP[3];
	vec_set(lastP,my.x);
	step=integer(random(10));
	
	while(1){
		step++;
		
		if(step>10){
			antInput();	
			if(my.carry>0){
				if(vec_dist(my.x,lastP)>8){
					pheromoneAdd(me,100);
					vec_set(lastP,my.x);	
				}
			}
			
			step=0;
		}
		antMove();
		
		wait(1);
	}
}


function antInput(){
	var phero=0;
	my.inputX=1;
	var temp1[3];
	ENTITY* ent1;
	ent1=ptr_for_handle(my.colony);

	if(my.carry>0||vec_dist(my.x,ent1.x)>140){		
		vec_set(temp1,nullvector);
		vec_sub(temp1,my.x);
		vec_rotate(temp1,vector(-my.pan,-my.tilt,0));
		phero+=sign(temp1[1])*5;
		if(vec_dist(my.x,ent1.x)<32){
			phero+=sign(temp1[1])*50;
		}
	}

	you=ent_next(NULL);
	while(you!=NULL){
		
		if(vec_dist(my.x,you.x)<32&&you!=me){
			vec_set(temp1,you.x);
			vec_sub(temp1,my.x);
			vec_rotate(temp1,vector(-my.pan,-my.tilt,0));
			
			if(my.carry==0&&temp1[0]>0){
				if(you.typ==TYP_PHEROMONE){
					phero+=sign(temp1[1]);
				}
				if(you.typ==TYP_FOOD){
					phero+=sign(temp1[1])*2;
				}
			}
			
			
		}
		
		you=ent_next(you);
	}	

	my.inputY=max(-1,min(phero*0.5,1));
	if(phero==0){
		my.inputY=random(2)-1;
	}
}

function antMove(){
	var temp1[3];
	var temp2[3];

	my.pan+=rotateSpeed*time_frame*my.inputY;

	vec_set(temp1,vector(moveSpeed*my.inputX*time_frame,0,0));
	vec_rotate(temp1,my.pan);
	vec_set(temp2,my.x);
	vec_add(temp2,temp1);
	vec_add(my.x,temp1);

	c_trace(my.x,vector(my.x,my.y,my.z-4),IGNORE_ME|IGNORE_PASSABLE|IGNORE_SPRITES|IGNORE_MODELS|USE_POLYGON);
	if(trace_hit){
		my.z=target.z+2;
	}
	else{
		my.z-=2;	
	}


	if(my.carry>0){
		you=ptr_for_handle(my.colony);
		if(vec_dist(my.x,you.x)<8){
			you.food++;
			my.carry=0;
		}
	}
	else{
		c_trace(my.x,temp2,IGNORE_ME|IGNORE_PASSABLE|IGNORE_SPRITES|USE_BOX);
		if(trace_hit){
			if(you!=NULL){
				if(you.typ==TYP_FOOD&&my.carry==0){
					my.carry=TYP_FOOD;
					ent_remove(you);				
				}
			}	
		}
	}

	my.inputY*=0.95;
}

function pheromoneMain(){
	my.skin=2;
	my.typ=TYP_PHEROMONE;
	set(my,PASSABLE|TRANSLUCENT);

	wait(1);

	while(my.value>0){
		my.value-=time_frame;
		my.alpha=my.value;
		
		wait(1);
	}

	ent_remove(me);
}


function pheromoneAdd(ENTITY* who,val){
	you=ent_create("sphere.mdl",who.x,pheromoneMain);
	you.id=who.id;
	you.value=val;
}



function foodMain(){
	my.skin=1;
	my.typ=TYP_FOOD;
	set(my,FLAG2);
	vec_scale(my.scale_x,2);
}

function foodSpawn(){
	var n;
	var temp1[3];

	for(n=0;n<200;n++){
		vec_set(temp1,vector(64+random(64),0,1000));
		vec_rotate(temp1,vector(random(36)+120*integer(random(3)),0,0));
		
		c_trace(temp1,vector(temp1[0],temp1[1],-1000),IGNORE_MODELS|IGNORE_SPRITES|IGNORE_PASSABLE|USE_POLYGON);
		vec_set(temp1,target);
		temp1[2]+=2;
		
		ent_create("sphere.mdl",temp1,foodMain);
	}
}


















